extern number time;
extern vec2 resolution;

vec3 iResolution = vec3(resolution.x, resolution.y, 100.0);
number iGlobalTime = time;

number rand(vec2 n) { 
  return fract(cos(dot(n, vec2(12.9898, 4.1414))) * 43758.5453);
}

number noise(vec2 n) {
  const vec2 d = vec2(0.0, 1.0);
  vec2 b = floor(n), f = smoothstep(vec2(0.0), vec2(1.0), fract(n));
  return mix(mix(rand(b), rand(b + d.yx), f.x), mix(rand(b + d.xy), rand(b + d.yy), f.x), f.y);
}

number fbm(vec2 n) {
  number total = 0.0, amplitude = 1.0;
  for (int i = 0; i < 4; i++) {
    total += noise(n) * amplitude;
    n += n;
    amplitude *= 0.5;
  }
  return total;
}

vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords)
{
  texture_coords = texture_coords - 0.5;
  
  const vec3 c1 = vec3(0.1, 0.0, 0.0);
  const vec3 c2 = vec3(0.7, 0.0, 0.0);
  const vec3 c3 = vec3(0.2, 0.0, 0.0);
  const vec3 c4 = vec3(1.0, 0.9, 0.0);
  const vec3 c5 = vec3(0.1);
  const vec3 c6 = vec3(0.9);
  
  vec2 p = texture_coords.xy * 16.0 / iResolution.xx;
  number q = fbm(p - iGlobalTime * 0.5);
  vec2 r = vec2(fbm(p + q + iGlobalTime * 0.7 - p.x - p.y), fbm(p + q - iGlobalTime * 0.4));
  vec3 c = mix(c1, c2, fbm(p + r)) + mix(c3, c4, r.x) - mix(c5, c6, r.y);
  return vec4(c * 
          cos(1.57 * texture_coords.y / iResolution.y),
          1.0);
}

